; Bombmania SNES-PAD Patch by DaNyL
; based upon code by Ninja/TheDreams
; 
; 64TASS snespad-abfrage.asm -o snespad-abfrage.prg
;
; $B3= Player 1 SNES1
; $B4= Player 2 SNES2
; $B5= Player 3 SNES3
; $B6= Player 4 $DC00
;
; BIT  0 : BUTTON B
; BIT  1 : BUTTON Y
; BIT  2 : SELECT
; BIT  3 : START
; BIT  4 : UP
; BIT  5 : DOWN
; BIT  6 : LEFT
; BIT  7 : RIGHT
; BIT  8 : BUTTON A
; BIT  9 : BUTTON X
; BIT 10 : TOP-LEFT L
; BIT 11 : TOP-RIGHT R
; BIT 12+: ALWAYS 1

              *=$0900
GETSNES
              TXA
              PHA
              TYA
              PHA              
              LDA $DC00
              AND #$1F
              STA $B6
              LDA #$F8      ; PB 0-2 = INPUT
              STA $DC03     ; PB 3-7 = OUTPUT
              LDA #$10      ; SEND "RESET" COMMAND
              STA $DC01     ; TO ALL PADS
              LDA #0        ; AND
              STA $DC01     ; CLEAR IT
              LDY #8        ; GET 8 BITS
LOOP3                       ; 
              LDX #2        ; COUNTER FOR 3 PADS
              LDA $DC01     ; GET DATA FROM JOYPORT 1
LOOP1
              LSR           ; SHIFT BIT FROM PAD INTO CARRY...
              ROR $B3,X     ; ...THEN INTO ITS DESTINATION
              DEX           ; DECREMENT COUNTER BY 2 AS WE USE
              BPL LOOP1     ; NO? THEN CONTINUE
              LDA #8        ; SEND "NEXT" COMMAND
              STA $DC01     ; TO ALL PADS
              LDA #0        ; AND
              STA $DC01     ; CLEAR IT
              DEY           ; DID WE GET ALL NEEDED BITS?
              BNE LOOP3     ; IF NOT, LOOP
              LDX #2
LOOP4
              LDA $B3,X     ; SWAP NIBBLES
              CMP #$80
              ROL
              CMP #$80
              ROL 
              CMP #$80
              ROL 
              CMP #$80
              ROL
              AND #$1F
              STA $B3,X
              DEX
              BPL LOOP4
              LDA #$00      ; NORMAL...
              STA $DC03     ; FOR KEYBOARD SCAN.
              PLA
              TAY
              PLA
              TAX
              RTS           ; GO BACK...
